SystemOrganization addCategory: #'Metacello-TestsPlatform'!

!MCFtpRepository methodsFor: '*metacello-testsplatform' stamp: 'dkh 6/12/2012 10:19:43.983'!
directory

	^directory! !

!MCFtpRepository methodsFor: '*metacello-testsplatform' stamp: 'dkh 6/12/2012 10:19:43.983'!
host

	^host! !

TestCase subclass: #MetacelloRepositorySqueakCommonTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Metacello-TestsPlatform'!

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'baselines' stamp: 'dkh 6/12/2012 10:19:43.983'!
baseline10: spec
    <version: '1.0-baseline'>
    spec
        for: #'common'
        do: [ 
            spec
                package: 'Example-Core'
                with: [ 
                    spec
                        includes: 'Example-AddOn';
                        file: 'Example-Core-anon.1';
                        repository: '/opt/mcexamples' ] ]! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'baselines' stamp: 'dkh 6/12/2012 10:19:43.983'!
baseline13: spec
    <version: '1.3-baseline'>
    spec
        for: #'squeakCommon'
        do: [ 
            spec
                package: 'Example-Core'
                with: [ 
                    spec
                        includes: 'Example-AddOn';
                        file: 'Example-Core-anon.1';
                        repository: 'ftp://ftp.example.com/examples' ] ]! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'baselines' stamp: 'dkh 6/12/2012 10:19:43.983'!
baseline14: spec
    <version: '1.4-baseline'>
    spec
        for: #'common'
        do: [ 
            spec
                package: 'Example-Core'
                with: [ 
                    spec
                        includes: 'Example-AddOn';
                        file: 'Example-Core-anon.1';
                        repository: 'http://example.com/examples' ] ]! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'baselines' stamp: 'dkh 6/12/2012 10:19:43.983'!
baseline15: spec
    <version: '1.5-baseline'>
    spec
        for: #'common'
        do: [ 
            spec
                package: 'Example-Core'
                with: [ 
                    spec
                        includes: 'Example-AddOn';
                        file: 'Example-Core-anon.1';
                        repository: 'dictionary://Metacello_Platform_Test_GlobalDictionary' ] ]! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'baselines' stamp: 'dkh 7/12/2013 07:03'!
baseline16: spec
  <version: '1.6-baseline'>
  spec
    for: #'common'
    do: [ 
      spec
        package: 'Example-Core'
        with: [ 
          spec
            includes: 'Example-AddOn';
            file: 'Example-Core-anon.1';
            repository:
                'filetree://' , MCFileTreeFileUtils current default fullName , '/temp/repo' ] ]

! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'accessing' stamp: 'dkh 5/7/2013 19:11'!
project
     "force new version as workaround for https://code.google.com/p/smalltalk-hub/issues/detail?id=21"

	| constructor project |
	"Construct Metacello project"
	constructor := MetacelloVersionConstructor on: self.
	project := constructor project.
	project loader: MetacelloNullRecordingMCSpecLoader new.
	^project! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'running' stamp: 'dkh 6/12/2012 10:19:43.983'!
setUp
    super setUp.
    Smalltalk
        at: #'Metacello_Platform_Test_GlobalDictionary'
        put:
            (MCDictionaryRepository new
                description: 'dictionary://Metacello_Platform_Test_GlobalDictionary';
                yourself)! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'running' stamp: 'dkh 6/12/2012 10:19:43.983'!
tearDown
    super tearDown.
    Smalltalk removeKey: #'Metacello_Platform_Test_GlobalDictionary' ifAbsent: [  ]! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 6/12/2012 10:19:43.983'!
testAsRepositorySpecFor
    | project testBlock |
    project := self project.
    testBlock := [ :pkg :expectedType1 :expectedType2 | 
    | repoSpec1 repo repoSpec2 |
    repoSpec1 := pkg repositorySpecs first.
    self assert: repoSpec1 type = expectedType1.
    repo := repoSpec1 createRepository.
    repoSpec2 := repo asRepositorySpecFor: project.
    self assert: repoSpec2 type = expectedType2.
    expectedType1 = expectedType2
        ifTrue: [ self assert: repoSpec1 description = repoSpec2 description ]
        ifFalse: [ 
            "special case for standard directory type that defaults to MCServerDirectoryRepository"
            self
                assert:
                    (repoSpec1 description copyFrom: 'server://' size + 1 to: repoSpec1 description size) = repoSpec2 description ] ].
    testBlock
        value: ((project version: '1.0-baseline') packageNamed: 'Example-Core')
        value: 'directory'
        value: 'directory'.
    testBlock value: ((project version: '1.3-baseline') packageNamed: 'Example-Core') value: 'ftp' value: 'ftp'.
    testBlock value: ((project version: '1.4-baseline') packageNamed: 'Example-Core') value: 'http' value: 'http'.
    testBlock
        value: ((project version: '1.5-baseline') packageNamed: 'Example-Core')
        value: 'dictionary'
        value: 'dictionary'! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 6/12/2012 10:19:43.983'!
testDictionaryRepository
    | project pkg repoSpec repo |
    project := self project.
    pkg := (project version: '1.5-baseline') packageNamed: 'Example-Core'.
    repoSpec := pkg repositorySpecs first.
    self assert: repoSpec type = 'dictionary'.
    repo := repoSpec createRepository.
    self assert: repo class == MCDictionaryRepository.
    self assert: repo dictionary == (Smalltalk at: #'Metacello_Platform_Test_GlobalDictionary') dictionary! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 6/12/2012 10:19:43.983'!
testDirectoryRepository
    | project pkg repoSpec repo |
    project := self project.
    pkg := (project version: '1.0-baseline') packageNamed: 'Example-Core'.
    repoSpec := pkg repositorySpecs first.
    self assert: repoSpec type = 'directory'.
    repo := repoSpec createRepository.
    self assert: repo class == MCDirectoryRepository.
    self assert: repo description = '/opt/mcexamples'! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 7/12/2013 07:03'!
testFileTreeRepository
  "must create repository against an existing directory"

  | project pkg repoSpec repo fileUtils workingDir tempDir repoDir |
  fileUtils := MCFileTreeFileUtils current.
  workingDir := fileUtils default.
  tempDir := fileUtils directoryFromPath: 'temp' relativeTo: workingDir.
  [ 
  fileUtils ensureDirectoryExists: tempDir.
  repoDir := fileUtils directoryFromPath: 'repo' relativeTo: tempDir.
  fileUtils ensureDirectoryExists: repoDir.
  project := self project.
  pkg := (project version: '1.6-baseline') packageNamed: 'Example-Core'.
  repoSpec := pkg repositorySpecs first.
  self assert: repoSpec type = 'filetree'.
  repo := repoSpec createRepository.
  self
    assert: repo class == (Smalltalk at: #'MCFileTreeRepository' ifAbsent: [  ]).
  self
    assert:
      repo description = ('filetree://' , fileUtils default fullName , '/temp/repo') ]
    ensure: [ 
      (fileUtils directoryExists: tempDir)
        ifTrue: [ fileUtils deleteAll: tempDir ] ]

! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 6/12/2012 10:19:43.983'!
testFtpRepository
    | project pkg repoSpec repo |
    project := self project.
    pkg := (project version: '1.3-baseline') packageNamed: 'Example-Core'.
    repoSpec := pkg repositorySpecs first.
    self assert: repoSpec type = 'ftp'.
    repo := repoSpec createRepository.
    self assert: repo class == MCFtpRepository.
    self assert: repo host = 'ftp.example.com'.
    self assert: repo directory = 'examples'! !

!MetacelloRepositorySqueakCommonTestCase methodsFor: 'tests' stamp: 'dkh 6/12/2012 10:19:43.983'!
testHttpRepository
    | project pkg repoSpec repo |
    project := self project.
    pkg := (project version: '1.4-baseline') packageNamed: 'Example-Core'.
    repoSpec := pkg repositorySpecs first.
    self assert: repoSpec type = 'http'.
    repo := repoSpec createRepository.
    self assert: repo class == MCHttpRepository.
    self assert: repo description = 'http://example.com/examples'! !
